config/routes.rb
Rails.application.routes.draw do
  get 'home/index'
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html

  resources :playlists do
    resources :songs
  end
  
  root 'home#index'

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/playlist.rb
class Playlist < ApplicationRecord
  has_many :songs, dependent: :destroy
  validates :title, presence: true
end

app/models/song.rb
class Song < ApplicationRecord
  belongs_to :playlist
  validates :name, presence: true
  validates :artist, presence: true
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end
end

app/controllers/playlists_controller.rb
class PlaylistsController < ApplicationController

  before_action :set_playlist, only: [:show, :edit, :update, :destroy]

  def index
    @playlists = Playlist.all
  end

  def show
    @song = @playlist.songs.new
  end

  def new
    @playlist = Playlist.new
  end

  def edit
  end

  def create
    @playlist = Playlist.new(playlist_params)

    if @playlist.save
      redirect_to @playlist
    else
      render 'new'
    end
  
  end

  def update
    if @playlist.update(playlist_params)
      redirect_to @playlist
    else
      render 'edit'
    end
  end

  def destroy
    @playlist.destroy 
    redirect_to playlists_path
  end

  private
  def playlist_params
    params.require(:playlist).permit(:title, :description)
  end

  def set_playlist
    @playlist = Playlist.find(params[:id])
  end
  
end

app/controllers/songs_controller.rb
class SongsController < ApplicationController
  before_action :set_playlist, only: [:create, :destroy]

  def create
    @song = @playlist.songs.build(song_params)

    if @song.save
      redirect_to playlist_path(@playlist)
    else
      render :new
    end
  end

  def destroy
    @song = @playlist.songs.find(params[:id])
    @song.destroy
    redirect_to playlist_path(@playlist)
  end
 
  private
  def song_params
    params.require(:song).permit(:name, :artist)
  end

  def set_playlist
    @playlist = Playlist.find(params[:playlist_id])
  end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/playlists_helper.rb
module PlaylistsHelper
end

app/helpers/songs_helper.rb
module SongsHelper
end

app/views/home/index.html.erb
<div class="home">
  <h1 class="title">my<span>Play</span>lists</h1>

  <div class= "playlists-link">
    <%= link_to 'Minhas playlists', controller: 'playlists' %>
  </div>

</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>MyPlaylist</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/playlists/_form.html.erb
<%= form_with model: @playlist, local: true do |form| %>
  <% if @playlist.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@playlist.errors.count, "error") %> prohibited
        this playlist from being saved:
      </h2>
      <ul>
        <% @playlist.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :Título %><br>
    <%= form.text_field :title %>
  </div>

  <div>
    <%= form.label :Descrição %><br>
    <%= form.text_area :description %>
  </div>

  <div class="new-actions">
    <%= form.submit "Criar" %>
    <%= link_to 'Voltar', playlists_path %>
  </div>
<% end %>

app/views/playlists/edit.html.erb
<div class="new-playlist">
  <h1>Editar playlist</h1>

  <%= render 'form' %>
</div>

app/views/playlists/index.html.erb
<div class="playlist-index">
  <h1>Minhas playlists</h1>

  <%= link_to 'Criar playlist', new_playlist_path %> 

  <table>
    <tr>
      <th>Title</th>
      <th>Description</th>
      <th></th>
    </tr>
  
    <% @playlists.each do |playlist| %>
      <tr>
        <td><%= playlist.title %></td>
        <td><%= playlist.description %></td>
        <td class="option"><%= link_to 'Mostrar', playlist_path(playlist) %></td>
        <td class="option"><%= link_to 'Editar', edit_playlist_path(playlist) %></td>
        <td class="option"><%= link_to 'Excluir', playlist_path(playlist),
                method: :delete,
                data: { confirm: 'Deseja excluir permanentemente?' } %></td>
      </tr>
    <% end %>
  </table>
<div>

app/views/playlists/new.html.erb
<div class="new-playlist"> 

  <h1>Nova playlist</h1>

  <%= render 'form' %>
  
</div>

app/views/playlists/show.html.erb
<div class="playlist">
  <h2>
    Título:
    <span><%= @playlist.title %></span>
  </h2>
  
  <h3>
    Descrição:
    <span><%= @playlist.description %></span>
  </h3>

  <%= link_to 'Editar', edit_playlist_path(@playlist) %>
  <br><br>
  <%= link_to 'Ver Todas', playlists_path %>
  <br><br>

  <h2>Músicas</h2>
  <table class="songs">
    <tr>
      <th>Nome</th>
      <th>Artista</th>
      <th></th>
    </tr>
    <%= render @playlist.songs %>
  </table>

  <br><br><br>

  <h2>Adicionar uma música:</h2>
  <%= render partial: 'songs/form', locals: {song: @playlist.songs.build} %>

<div>

app/views/songs/_form.html.erb
<%= form_with(model: song, local: true, url: playlist_songs_path(@playlist.id)) do |form| %>
  <p>
    <%= form.label :Nome %><br>
    <%= form.text_field :name, required: true %>
  </p>
  <p>
    <%= form.label :Artista %><br>
    <%= form.text_field :artist, required: true %>
  </p>
  <p>
    <%= form.submit "Adicionar"%>
  </p>
<% end %>

app/views/songs/_song.html.erb
<tr>
  <td> <%= song.name %> </td>
  <td> <%= song.artist %> </td>
  <td>
    <%= link_to 'Excluir', [song.playlist, song],
                method: :delete,
                data: { confirm: 'Deseja realmente excluir?' } %>
  </td>
</tr>

app/views/songs/new.html.erb
<%= render partial: 'form', song: @song %>